hi Mehdi,
                 Why should we consider from left to right only or right to
left only ? Explanation you gave does not look like proof that it gives
optimal solution. We should be able to prove that any other matching
strategy is not better than greedy approach mentioned. The example I gave
is to show that choosing greedily arbitrarily does not give optimal
solution because some other better solution exists.

-Thanks
Bujji

On Sat, Nov 18, 2017 at 1:17 AM, MeHdi KaZemI <mehdi.kaze...@gmail.com>
wrote:

>
> The Greedy observation is something like this: the leftmost person needs
> to satisfy his/her requirement from someone on his right, (i.e. if he wants
> to sell he has to sell to someone on his right, if he needs to buy he has
> to buy from someone on his right)
>
> Try to traverse the street from left to right, and only care about match
> for negative numbers, for example in the example you posted -1 -1 2 -1 1,
> when we traverse from [0] cell to the [1] cell we know 1 bottle of wine has
> to pass from [1] to [0] to satisfy the first person, *so 1 unit of work
> here*, then we see it's not satisfied from [1], so we keep in mind and
> continue,
> we traverse from [1] to [2], then we know 2 bottles has to pass from [2]
> to [1] to satisfy [0] and [1], *so 2 units of work here,*
> then we traverse from [2] to [3] we know no bottle has to pass from [3] to
> [2] to satisfy previous people because sum of the numbers we have seen so
> far is zero, then they have been able to satisfy each others needs. and so
> on....
>
>
>
>
> On Thu, Nov 16, 2017 at 10:33 PM, bujji jajala <jajalabu...@gmail.com>
> wrote:
>
>> Hi,
>>         I am trying  to solve this problem in spoj website.  you might be
>> aware of this website.
>>
>> http://www.spoj.com/problems/GERGOVIA
>>
>>
>> Gergovia consists of one street, and every inhabitant of the city is a
>> wine salesman. Everyone buys wine from other inhabitants of the city. Every
>> day each inhabitant decides how much wine he wants to buy or sell.
>> Interestingly, demand and supply is always the same, so that each
>> inhabitant gets what he wants.
>>
>> There is one problem, however: Transporting wine from one house to
>> another results in work. Since all wines are equally good, the inhabitants
>> of Gergovia don't care which persons they are doing trade with, they are
>> only interested in selling or buying a specific amount of wine.
>>
>> In this problem you are asked to reconstruct the trading during one day
>> in Gergovia. For simplicity we will assume that the houses are built along
>> a straight line with equal distance between adjacent houses. Transporting
>> one bottle of wine from one house to an adjacent house results in one unit
>> of work.
>>
>>
>> Input
>>
>> The input consists of several test cases.
>>
>> Each test case starts with the number of inhabitants N (2 ≤ N ≤ 100000).
>>
>> The following line contains n integers ai (-1000 ≤ ai ≤ 1000).
>>
>> If ai ≥ 0, it means that the inhabitant living in the ith house wants to
>> buy ai bottles of wine. If ai < 0, he wants to sell -aibottles of wine.
>>
>> You may assume that the numbers ai sum up to 0.
>>
>> The last test case is followed by a line containing 0.
>> Output
>>
>> For each test case print the minimum amount of work units needed so that
>> every inhabitant has his demand fulfilled.
>>
>>
>> I tried  but failed. I came across solutions which say we need to
>> greedily choose houses which satisfy our requirement from either left end
>> or right end. But I do not find good reasoning or proof for this approach.
>> There are few comments asking for explanation. But they do not have any
>> response.
>>
>> Suppose houses have wine requirement like this -1,-1,2,-1,1. In this case
>> if House with 2 wine bottles requirement chooses greedily, we get cost to
>> be 2 plus cost to transfer wine bottle from left edge to right edge. (2+4
>> =6). But we can see if we choosing greedily from one end gives cost  2+1+1
>> = 4. Why greedy approach from one end succeeds while choosing arbitrarily
>> fails.
>>
>>
>> Any hints or proofs is greatly appreciated.
>>
>>
>> --
>> -Thanks
>> Bujji
>>
>> --
>> You received this message because you are subscribed to the Google Groups
>> "Algorithm Geeks" group.
>> To unsubscribe from this group and stop receiving emails from it, send an
>> email to algogeeks+unsubscr...@googlegroups.com.
>>
>
>
>
> --
>    MeHdi KaZemI
>
> --
> You received this message because you are subscribed to the Google Groups
> "Algorithm Geeks" group.
> To unsubscribe from this group and stop receiving emails from it, send an
> email to algogeeks+unsubscr...@googlegroups.com.
>

-- 
You received this message because you are subscribed to the Google Groups 
"Algorithm Geeks" group.
To unsubscribe from this group and stop receiving emails from it, send an email 
to algogeeks+unsubscr...@googlegroups.com.

Reply via email to